package de.mdelab.mlstorypatterns.ocl;

import java.util.Map;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.jface.text.source.ISourceViewer;
import org.eclipse.swt.widgets.Composite;

import de.mdelab.mlstorypatterns.diagram.custom.part.expressions.SourceViewerProvider;

public class OCLSourceViewerProvider extends SourceViewerProvider
{
	private OCLSourceViewerProvider	oclSourceViewer	= null;
	private ColorManager	colorManager	= null;

	@Override
	public ISourceViewer createSourceViewer(Composite parent, int styles, EClassifier contextClassifier,
			Map<String, EClassifier> contextInformation, String text)
	{
		colorManager = new ColorManager();

		oclSourceViewer = new OCLSourceViewerProvider();

		return (ISourceViewer) oclSourceViewer;
	}

	@Override
	public void dispose()
	{
		if (colorManager != null)
			colorManager.dispose();
	}

	@Override
	public String getText()
	{
		return OCLSourceViewerProvider.this.getText();
	}

	public void setText(String text)
	{
		oclSourceViewer.setText(text);
	}
}
